  var cmn = Components.classes["RgCommon"].createInstance(Components.interfaces.nsIRgCommon);

  function DownloadBy() {
    var url = Components.classes["RgUrl"].createInstance(Components.interfaces.nsIRgUrl);
    url.url = gContextMenu.linkURL();
    url.info = gContextMenu.linkText();
    url.referer = window._content.location.href;
    url.add();
  }

  function DownloadAll() {
    var list = Components.classes["RgUrlList"].createInstance(Components.interfaces.nsIRgUrlList);
    var doc = gContextMenu.target.ownerDocument;
    var links = doc.links
    for (i = 0; i < links.length; i++) {
      var url = Components.classes["RgUrl"].createInstance(Components.interfaces.nsIRgUrl);
      url.url = links[i].href;
      url.info = links[i].text;
      url.referer = window._content.location.href;
      list.add(url);
    }
    list.list();
  }

  function initReGetContextMenuItems(aEvent) {
    if (cmn.menu1 != null) {
      var s=cmn.menu1;
      r=s.search("&");

      if (r!=-1) {
        document.getElementById("download-by-catcher").setAttribute("accesskey", s.charAt(r+1).toLowerCase( ));
      }
      else {
        document.getElementById("download-by-catcher").setAttribute("accesskey", "");
      }

     // s=s.replace("&","");
     // document.getElementById("download-by-catcher").setAttribute("label", s);
    }

    if (cmn.menu2 != null) {
      var s=cmn.menu2;
      r=s.search("&");

      if (r!=-1) {
        document.getElementById("download-all-by-catcher").setAttribute("accesskey", s.charAt(r+1).toLowerCase( ));
      }
      else {
        document.getElementById("download-all-by-catcher").setAttribute("accesskey", "");
      }

     // s=s.replace("&","");
     // document.getElementById("download-all-by-catcher").setAttribute("label", s);
    }

    gContextMenu.showItem("download-by-catcher", gContextMenu.onSaveableLink);
    gContextMenu.showItem("context-sep-reget-start", gContextMenu.onSaveableLink);
  }

  function initReGetContextMenuListener(aEvent)
  {
    var contentAreaContextMenu = window.document.getElementById("contentAreaContextMenu");

    if (contentAreaContextMenu)
      contentAreaContextMenu.addEventListener("popupshowing", initReGetContextMenuItems, false);

    window.removeEventListener("load", initReGetContextMenuListener, true);
  }

  function altKeyDownloadBy(aEvent)
  {
    if (cmn.catchLinks) {
      if (aEvent.button == 0 && (aEvent.altKey || !cmn.useAlt)) {
        var linkNode;
        var localName = aEvent.target.localName;

        if (localName) {
          localName = localName.toLowerCase();
        }

        switch (localName) {
          case "a":
          case "area":
          case "link":
            if (aEvent.target.hasAttribute("href"))
              linkNode = aEvent.target;
            break;
          default:
            linkNode = findParentNode(aEvent.originalTarget, "a");
            if (linkNode && !linkNode.hasAttribute("href"))
              linkNode = null;
            break;
        }

        if (linkNode) {
          var text = gatherTextUnder(linkNode);

          if (!text || !text.match(/\S/)) {
            text = linkNode.getAttribute("title");
            if (!text || !text.match(/\S/)) {
              text = linkNode.getAttribute("alt");
              if (!text || !text.match(/\S/)) {
                text = linkNode.href;
              }
            }
          }

          var url = Components.classes["RgUrl"].createInstance(Components.interfaces.nsIRgUrl);
          url.url = linkNode.href;
          url.info = text;
          url.referer = window._content.location.href;
          url.add();
        }
      }
    }
  }

  window.addEventListener("load", initReGetContextMenuListener, true);
  getBrowser().addEventListener("click", altKeyDownloadBy, true);